package ga.core;

/**
 *
 *
 * @author Olly Oechsle, University of Essex, Date: 18-May-2007
 * @version 1.0
 */
public abstract class GAProblem {

    public abstract String getName();

    /**
     * Initialises the individual with a specified set of parameters.
     */
    public abstract GAIndividual createIndividual();


    /**
     * Gets the params for this evolution
     */
    public GAParams getParams() {
        return new GAParams();
    }

    public abstract void evaluate(GAIndividual ind);

    protected double[] weights = null;

    public void setWeights(double[] weights) {
        this.weights = weights;
    }

    /**
     * Allows the same problem to evaluate different functions. 
     */
    public int countFunctions() {
        return 1;
    }

    protected int functionID = 0;


    public int getFunctionID() {
        return functionID;
    }

    public void setFunctionID(int functionID) {
        this.functionID = functionID;
    }

    public void onFinish(GAIndividual ind) {
        // do nothing
    }

}
