package ga.util;

import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.plot.PlotOrientation;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;

/**
 * Allows graphs to be displayed easily
 *
 * @author Olly Oechsle, University of Essex, Date: 21-May-2007
 * @version 1.0
 */
public class GraphPanel extends JPanel {

    private JLabel chart;
    private DefaultCategoryDataset series;

    public GraphPanel() {
        series = new DefaultCategoryDataset();
        chart = new JLabel();
        add(chart, BorderLayout.CENTER);
    }

    public void addValue(double value, int generation) {
        series.addValue(value, "1", String.valueOf(generation));
        JFreeChart myChart = ChartFactory.createLineChart(null, "Generation", "Fitness", series, PlotOrientation.VERTICAL, false, false, false);
        BufferedImage image = myChart.createBufferedImage(getWidth(), getHeight());
        chart.setIcon(new ImageIcon(image));
    }

}
