package problems.boosting;

import ga.core.GAIndividual;
import ac.essex.ooechs.adaboost.AdaBoostLearner;
import ac.essex.ooechs.adaboost.AdaBoostSample;

/**
 * Wraps a GA Individual so that it can be applied to adaboost.
 *
 * @author Olly Oechsle, University of Essex, Date: 21-May-2007
 * @version 1.0
 */
public class GAWeakLearner extends AdaBoostLearner {

    GAIndividual ind;

    public GAWeakLearner(GAIndividual ind) {
        this.ind = ind;
        individualTP = ind.getHits();
    }

    public int classify(AdaBoostSample sample, Object data) {

        return ind.classify(sample.getData());

    }

}
